package it.unibas.mastermind.test;

import it.unibas.mastermind.modello.Combinazione;
import junit.framework.*;
import it.unibas.utilita.Logger;

public class TestCombinazione extends TestCase {
    
    private Combinazione comb;
    
    public TestCombinazione(String name) {
        super(name);
        //Logger.setLevel(java.util.logging.Level.FINE);
    }

    protected void setUp() throws java.lang.Exception {
        comb = new Combinazione();
    }
    
    protected void tearDown() throws java.lang.Exception {
    }
    
    public void testGenera() {
        for (int x = 0; x < 100; x++) {
            comb.genera();
            Logger.logFine("Combinazione", "genera", comb.toString());
            for (int i = 0; i < Combinazione.CIFRECOMBINAZIONE; i++) {
                Assert.assertEquals(contaOccorrenze(comb.getCifra(i), comb.toString()), 1);
            }
        }
    }
    
    public void testSetCifra() {
        comb.setCifra(1, 1);
        try {  
            comb.setCifra(2, 1);
            Assert.fail();
        } catch (Throwable t) {
            
        }
    }
    
    private int contaOccorrenze(int cifra, String comb) {
        Logger.logFine((char)(cifra + 48) + " " + comb);
        int conta = 0;
        char[] array = comb.toCharArray();
        for (int i = 0; i < array.length; i++) {
            if (array[i] == (char)(cifra + 48)) {
                conta++;
            }
        }
        return conta;
    }
    
}
